#include "my color.h"
#define totalColors			255				/* use 255 colors in our palette for drawing eyes. */
#define numColors			253				/* to skip black and white. */

/*
**	Use the Palette currently attached to the main window to animate the colors 
**	in the circular eye shapes.  This will rotate them around to give the flowing 
**	tube effect. We make the palette into a color table so we can move entries 
**	around.	We have to skip the first two entries since those are black and white. 
**	(entries 0 and 1)
*/
void ShiftyColors(myWindow)
CWindowPtr	myWindow;
{
PaletteHandle	currPalette;
CTabHandle		destCTab;
ColorSpec		lastCSpec;

	if(!myWindow) return;			/* if myWindow is NIL then return, there isn't a palette to animate */
	SetPort (myWindow);	
	currPalette = GetPalette(myWindow);
	destCTab = (CTabHandle) NewHandle(sizeof(ColorTable)+(totalColors*sizeof(ColorSpec)));
	if (destCTab == nil)  return;
	Palette2CTab(currPalette, destCTab);
	
	/*
	**	Move the colors around in the color table, skipping 0 and 1, and moving
	**	all the elements down by one, and copying the element at 2 back to the 
	**	end of the table. The effect is to rotate the colors in the table.
	*/
	lastCSpec = (*destCTab)->ctTable[2];						/* pull first one off. */
	BlockMove (&(*destCTab)->ctTable[3], 
			   &(*destCTab)->ctTable[2], 
			   (numColors) * sizeof(ColorSpec) );				/* copy all one entry down. */
	(*destCTab)->ctTable[totalColors-1] = lastCSpec;			/* put last color back on front. */
		
	AnimatePalette(myWindow, destCTab, 2, 2, numColors);
	
	DisposHandle ((Handle) destCTab);
}

